window.addEventListener('DOMContentLoaded', (event) => {
  console.log('DOMContentLoaded event fired');
  findAndRedirect();
});

function findAndRedirect() {
  console.log("Performing safety check for 'All' div");

  // Define the XPath expression for the 'All' div
  const allDivXpath = "//div[text()='All' and not(ancestor::a[@href])]";

  // Evaluate the XPath expression
  const allDivResult = document.evaluate(allDivXpath, document, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
  const allDiv = allDivResult.singleNodeValue;

  if (allDiv) {
    console.log("'All' div found and it is not inside an anchor tag. Proceeding to find target div with text 'Web'.");

    // Define the XPath expression for the 'Web' div
    const xpath = "//div[contains(text(),'Web')]/ancestor::a[@href]";

    // Evaluate the XPath expression
    const result = document.evaluate(xpath, document, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null);
    const anchor = result.singleNodeValue;

    if (anchor) {
      console.log("Found parent link:", anchor.href);
      const relativeUrl = anchor.getAttribute('href').substring(1); // Remove the leading slash
      const newUrl = `https://www.google.com/${relativeUrl}`;
      console.log("New URL to redirect:", newUrl);
      chrome.runtime.sendMessage({ action: "redirect", url: newUrl }, function(response) {
        console.log("Message sent to background script");
        if (chrome.runtime.lastError) {
          console.error("Error sending message:", chrome.runtime.lastError);
        }
      });
      // Disconnect observer
      observer.disconnect();
    } else {
      console.log("Target div not found or no href attribute");
    }
  } else {
    console.log("'All' div not found or it is inside an anchor tag. Aborting redirect.");
  }
}

// Use MutationObserver to observe changes in the DOM
const observer = new MutationObserver((mutations, obs) => {
  // Try to find and redirect
  findAndRedirect();
});

// Start observing the document for changes
observer.observe(document, {
  childList: true,
  subtree: true
});
